// MAIN.CPP
//  

#define Uses_TApplication
#define Uses_TEditWindow
#define Uses_TDeskTop
#define Uses_TRect
#define Uses_TEditor
#define Uses_TFileEditor
#define Uses_TFileDialog
#define Uses_TChDirDialog
#define Uses_TStaticText
#define Uses_TButton

#include <tv.h>

//砥 ᠭ ᮢ
#include "edit.h"

#include <stdlib.h>
#include <stdarg.h>
#include <strstrea.h>
#include <iomanip.h>

TEditWindow *TEditorApp::openEditor( const char *fileName, Boolean visible ) {
 //㭪  䠩. ࠬ -  䠩  ० 
 TRect r = deskTop->getExtent();
 TView *p = validView( new TEditWindow( r, fileName, wnNoNumber ) );
 if( !visible ) p->hide();
 deskTop->insert( p );
 return (TEditWindow *)p;
}

TEditorApp::TEditorApp() : TProgInit( TEditorApp::initStatusLine,
  TEditorApp::initMenuBar, TEditorApp::initDeskTop), TApplication() {
 //⪫砥 㯭 㭪  १ 
 TCommandSet ts;
 ts.enableCmd( cmSave );
 ts.enableCmd( cmSaveAs );
 ts.enableCmd( cmUndo );
 ts.enableCmd( cmFind );
 ts.enableCmd( cmReplace );
 ts.enableCmd( cmSearchAgain );
 disableCommands( ts );
 TEditor::editorDialog = doEditDialog;
}

void TEditorApp::fileOpen() { //  䠩
 char fileName[MAXPATH];
 strcpy( fileName, "*.*" );
 if( execDialog( new TFileDialog( "*.*", " 䠩",
   "~~", fdOpenButton, 100 ), fileName) != cmCancel )
 openEditor( fileName, True );
}

void TEditorApp::fileNew() { // 
 openEditor( 0, True );
}

void TEditorApp::tile() {  //  
 deskTop->tile( deskTop->getExtent() );
}

void TEditorApp::cascade() { //  ᪠
 deskTop->cascade( deskTop->getExtent() );
}

void TEditorApp::About() { // 
 TDialog *d = new TDialog(TRect( 10, 5, 68, 18 ), " ணࠬ" );
 d->insert( new TStaticText( TRect( 2, 1, 52, 9 ),
  "।  - ਬ ⮣ ⥪⮢ ।.\n"
  "᭮ ࠢ騥 :\n"
  "F10   -   \n"
  "F3    -  䠩  ᪠\n"
  "Alt+X -   ।\n"
  "\n"
  " ⠪  !\n"
  "ணࠬ ᠭ  ++  ᯮ짮 \n"
  "Turbo Vision. 2000."
 ) );
 d->insert( new TButton( TRect( 44, 10, 56, 12 ), "", cmCancel, bfNormal ) );
 deskTop->execView( d );
 destroy(d);
}

void TEditorApp::handleEvent( TEvent& event ) { //ࠡ稪 ᮡ⨩
 TApplication::handleEvent( event );
 if( event.what != evCommand ) return;
 else switch( event.message.command ) {
  case cmOpen:
   fileOpen();
  break;
  case cmNew:
   fileNew();
  break;
  case cmAbout:
   About();
  break;
  case cmTile:
   tile();
  break;
  case cmCascade:
   cascade();
  break;
  default: return ;
 }
 clearEvent( event );
}

int main() {
 TEditorApp editorApp;
 editorApp.run();
 return 0;
}
